Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/AdministrationService.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/AdministrationService.cs	(revision 5481)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/AdministrationService.cs	(revision 5482)
@@ -22,7 +22,5 @@
 using System;
 using System.Collections.Generic;
-using System.Data.Linq;
 using System.Linq;
-using System.Security.Cryptography;
 using System.ServiceModel;
 using HeuristicLab.Services.OKB.DataAccess;
@@ -35,9 +33,4 @@
   public class AdministrationService : IAdministrationService {
     #region Platform Methods
-    public DataTransfer.Platform GetPlatform(long id) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        return Convert.ToDto(okb.Platforms.FirstOrDefault(x => x.Id == id));
-      }
-    }
     public IEnumerable<DataTransfer.Platform> GetPlatforms() {
       using (OKBDataContext okb = new OKBDataContext()) {
@@ -69,57 +62,5 @@
     #endregion
 
-    #region DataType Methods
-    public DataTransfer.DataType GetDataType(long id) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        return Convert.ToDto(okb.DataTypes.FirstOrDefault(x => x.Id == id));
-      }
-    }
-    public long AddDataType(DataTransfer.DataType dto) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        var entity = okb.DataTypes.Where(x => (x.PlatformId == dto.PlatformId) && (x.Name == dto.Name) && (x.TypeName == dto.TypeName)).FirstOrDefault();
-        if (entity == null) {
-          entity = Convert.ToEntity(dto); entity.Id = 0;
-          okb.DataTypes.InsertOnSubmit(entity);
-          okb.SubmitChanges();
-        }
-        return entity.Id;
-      }
-    }
-    #endregion
-
-    #region BinaryData Methods
-    public long GetBinaryDataId(byte[] hash) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        var id = okb.BinaryDatas.Where(x => x.Hash.Equals(hash)).Select(x => x.Id).FirstOrDefault();
-        if (id == 0) return -1;
-        else return id;
-      }
-    }
-    public long AddBinaryData(DataTransfer.BinaryData dto) {
-      byte[] hash;
-      using (SHA1 sha1 = SHA1.Create()) {
-        hash = sha1.ComputeHash(dto.Data);
-      }
-
-      using (OKBDataContext okb = new OKBDataContext()) {
-        var id = okb.BinaryDatas.Where(x => x.Hash.Equals(hash)).Select(x => x.Id).FirstOrDefault();
-        if (id != 0) {
-          return id;
-        } else {
-          DataAccess.BinaryData entity = Convert.ToEntity(dto); entity.Id = 0;
-          okb.BinaryDatas.InsertOnSubmit(entity);
-          okb.SubmitChanges();
-          return entity.Id;
-        }
-      }
-    }
-    #endregion
-
     #region AlgorithmClass Methods
-    public DataTransfer.AlgorithmClass GetAlgorithmClass(long id) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        return Convert.ToDto(okb.AlgorithmClasses.FirstOrDefault(x => x.Id == id));
-      }
-    }
     public IEnumerable<DataTransfer.AlgorithmClass> GetAlgorithmClasses() {
       using (OKBDataContext okb = new OKBDataContext()) {
@@ -152,9 +93,4 @@
 
     #region Algorithm Methods
-    public DataTransfer.Algorithm GetAlgorithm(long id) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        return Convert.ToDto(okb.Algorithms.FirstOrDefault(x => x.Id == id));
-      }
-    }
     public IEnumerable<DataTransfer.Algorithm> GetAlgorithms() {
       using (OKBDataContext okb = new OKBDataContext()) {
@@ -164,5 +100,5 @@
     public long AddAlgorithm(DataTransfer.Algorithm dto) {
       using (OKBDataContext okb = new OKBDataContext()) {
-        DataAccess.Algorithm entity = Convert.ToEntity(dto); entity.Id = 0;
+        DataAccess.Algorithm entity = Convert.ToEntity(dto, okb); entity.Id = 0;
         okb.Algorithms.InsertOnSubmit(entity);
         okb.SubmitChanges();
@@ -173,5 +109,5 @@
       using (OKBDataContext okb = new OKBDataContext()) {
         DataAccess.Algorithm entity = okb.Algorithms.FirstOrDefault(x => x.Id == dto.Id);
-        Convert.ToEntity(dto, entity);
+        Convert.ToEntity(dto, entity, okb);
         okb.SubmitChanges();
       }
@@ -196,10 +132,15 @@
       }
     }
-    public DataTransfer.BinaryData GetAlgorithmData(long algorithmId) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        DataLoadOptions dlo = new DataLoadOptions();
-        dlo.LoadWith<Algorithm>(x => x.BinaryData);
-        okb.LoadOptions = dlo;
-        return Convert.ToDto(okb.Algorithms.Where(x => x.Id == algorithmId).Select(x => x.BinaryData).FirstOrDefault());
+    public byte[] GetAlgorithmData(long algorithmId) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        return okb.Algorithms.Where(x => x.Id == algorithmId).Select(x => x.BinaryData.Data.ToArray()).FirstOrDefault();
+      }
+    }
+    public void UpdateAlgorithmData(long algorithmId, byte[] data) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        var entity = okb.Algorithms.Where(x => x.Id == algorithmId).FirstOrDefault();
+        if (entity != null)
+          entity.BinaryData = Convert.ToEntity(data, okb);
+        okb.SubmitChanges();
       }
     }
@@ -207,9 +148,4 @@
 
     #region ProblemClass Methods
-    public DataTransfer.ProblemClass GetProblemClass(long id) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        return Convert.ToDto(okb.ProblemClasses.FirstOrDefault(x => x.Id == id));
-      }
-    }
     public IEnumerable<DataTransfer.ProblemClass> GetProblemClasses() {
       using (OKBDataContext okb = new OKBDataContext()) {
@@ -242,9 +178,4 @@
 
     #region Problem Methods
-    public DataTransfer.Problem GetProblem(long id) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        return Convert.ToDto(okb.Problems.FirstOrDefault(x => x.Id == id));
-      }
-    }
     public IEnumerable<DataTransfer.Problem> GetProblems() {
       using (OKBDataContext okb = new OKBDataContext()) {
@@ -254,5 +185,5 @@
     public long AddProblem(DataTransfer.Problem dto) {
       using (OKBDataContext okb = new OKBDataContext()) {
-        DataAccess.Problem entity = Convert.ToEntity(dto); entity.Id = 0;
+        DataAccess.Problem entity = Convert.ToEntity(dto, okb); entity.Id = 0;
         okb.Problems.InsertOnSubmit(entity);
         okb.SubmitChanges();
@@ -263,5 +194,5 @@
       using (OKBDataContext okb = new OKBDataContext()) {
         DataAccess.Problem entity = okb.Problems.FirstOrDefault(x => x.Id == dto.Id);
-        Convert.ToEntity(dto, entity);
+        Convert.ToEntity(dto, entity, okb);
         okb.SubmitChanges();
       }
@@ -286,63 +217,14 @@
       }
     }
-    public DataTransfer.BinaryData GetProblemData(long problemId) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        DataLoadOptions dlo = new DataLoadOptions();
-        dlo.LoadWith<Problem>(x => x.BinaryData);
-        okb.LoadOptions = dlo;
-        return Convert.ToDto(okb.Problems.Where(x => x.Id == problemId).Select(x => x.BinaryData).FirstOrDefault());
-      }
-    }
-    #endregion
-
-    #region Run Methods
-    public DataTransfer.Run GetRun(long id) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        DataLoadOptions dlo = new DataLoadOptions();
-        dlo.LoadWith<Run>(x => x.Values);
-        dlo.LoadWith<Value>(x => x.ValueName);
-        okb.LoadOptions = dlo;
-        return Convert.ToDto(okb.Runs.FirstOrDefault(x => x.Id == id));
-      }
-    }
-    public IEnumerable<DataTransfer.Run> GetRuns(long algorithmId, long problemId) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        DataLoadOptions dlo = new DataLoadOptions();
-        dlo.LoadWith<Run>(x => x.Values);
-        dlo.LoadWith<Value>(x => x.ValueName);
-        okb.LoadOptions = dlo;
-        if ((algorithmId != 0) && (problemId != 0))
-          return okb.Runs.Where(x => (x.AlgorithmId == algorithmId) && (x.ProblemId == problemId)).Select(x => Convert.ToDto(x)).ToArray();
-        else if (algorithmId != 0)
-          return okb.Runs.Where(x => x.AlgorithmId == algorithmId).Select(x => Convert.ToDto(x)).ToArray();
-        else if (problemId != 0)
-          return okb.Runs.Where(x => x.ProblemId == problemId).Select(x => Convert.ToDto(x)).ToArray();
-        else
-          return okb.Runs.Select(x => Convert.ToDto(x)).ToArray();
-      }
-    }
-    public long AddRun(DataTransfer.Run dto) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        DataAccess.Run entity = Convert.ToEntity(dto); entity.Id = 0;
-        okb.Runs.InsertOnSubmit(entity);
-        okb.SubmitChanges();
-        return entity.Id;
-      }
-    }
-    public void DeleteRun(long id) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        IEnumerable<DataAccess.ResultBlobValue> resultBlobValues = okb.ResultBlobValues.Where(x => x.RunId == id);
-        okb.ResultBlobValues.DeleteAllOnSubmit(resultBlobValues);
-        IEnumerable<DataAccess.ResultBoolValue> resultBoolValues = okb.ResultBoolValues.Where(x => x.RunId == id);
-        okb.ResultBoolValues.DeleteAllOnSubmit(resultBoolValues);
-        IEnumerable<DataAccess.ResultFloatValue> resultFloatValues = okb.ResultFloatValues.Where(x => x.RunId == id);
-        okb.ResultFloatValues.DeleteAllOnSubmit(resultFloatValues);
-        IEnumerable<DataAccess.ResultIntValue> resultIntValues = okb.ResultIntValues.Where(x => x.RunId == id);
-        okb.ResultIntValues.DeleteAllOnSubmit(resultIntValues);
-        IEnumerable<DataAccess.ResultStringValue> resultStringValues = okb.ResultStringValues.Where(x => x.RunId == id);
-        okb.ResultStringValues.DeleteAllOnSubmit(resultStringValues);
-
-        DataAccess.Run entity = okb.Runs.FirstOrDefault(x => x.Id == id);
-        if (entity != null) okb.Runs.DeleteOnSubmit(entity);
+    public byte[] GetProblemData(long problemId) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        return okb.Problems.Where(x => x.Id == problemId).Select(x => x.BinaryData.Data.ToArray()).FirstOrDefault();
+      }
+    }
+    public void UpdateProblemData(long problemId, byte[] data) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        var entity = okb.Problems.Where(x => x.Id == problemId).FirstOrDefault();
+        if (entity != null)
+          entity.BinaryData = Convert.ToEntity(data, okb);
         okb.SubmitChanges();
       }
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/Convert.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/Convert.cs	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/Convert.cs	(revision 5482)
@@ -0,0 +1,137 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using System.Security.Cryptography;
+using DA = HeuristicLab.Services.OKB.DataAccess;
+using DT = HeuristicLab.Services.OKB.Administration.DataTransfer;
+
+namespace HeuristicLab.Services.OKB.Administration {
+  public static class Convert {
+    #region Platform
+    public static DT.Platform ToDto(DA.Platform source) {
+      if (source == null) return null;
+      return new DT.Platform { Id = source.Id, Name = source.Name, Description = source.Description };
+    }
+    public static DA.Platform ToEntity(DT.Platform source) {
+      if (source == null) return null;
+      return new DA.Platform { Id = source.Id, Name = source.Name, Description = source.Description };
+    }
+    public static void ToEntity(DT.Platform source, DA.Platform target) {
+      if ((source != null) && (target != null)) {
+        target.Id = source.Id; target.Name = source.Name; target.Description = source.Description;
+      }
+    }
+    #endregion
+
+    #region AlgorithmClass
+    public static DT.AlgorithmClass ToDto(DA.AlgorithmClass source) {
+      if (source == null) return null;
+      return new DT.AlgorithmClass { Id = source.Id, Name = source.Name, Description = source.Description };
+    }
+    public static DA.AlgorithmClass ToEntity(DT.AlgorithmClass source) {
+      if (source == null) return null;
+      return new DA.AlgorithmClass { Id = source.Id, Name = source.Name, Description = source.Description };
+    }
+    public static void ToEntity(DT.AlgorithmClass source, DA.AlgorithmClass target) {
+      if ((source != null) && (target != null)) {
+        target.Id = source.Id; target.Name = source.Name; target.Description = source.Description;
+      }
+    }
+    #endregion
+
+    #region Algorithm
+    public static DT.Algorithm ToDto(DA.Algorithm source) {
+      if (source == null) return null;
+      return new DT.Algorithm { Id = source.Id, Name = source.Name, Description = source.Description, PlatformId = source.PlatformId, AlgorithmClassId = source.AlgorithmClassId, DataType = Convert.ToDto(source.DataType) };
+    }
+    public static DA.Algorithm ToEntity(DT.Algorithm source, DA.OKBDataContext okb) {
+      if (source == null) return null;
+      return new DA.Algorithm { Id = source.Id, Name = source.Name, Description = source.Description, PlatformId = source.PlatformId, AlgorithmClassId = source.AlgorithmClassId, DataType = Convert.ToEntity(source.DataType, okb) };
+    }
+    public static void ToEntity(DT.Algorithm source, DA.Algorithm target, DA.OKBDataContext okb) {
+      if ((source != null) && (target != null)) {
+        target.Id = source.Id; target.Name = source.Name; target.Description = source.Description; target.PlatformId = source.PlatformId; target.AlgorithmClassId = source.AlgorithmClassId; target.DataType = Convert.ToEntity(source.DataType, okb);
+      }
+    }
+    #endregion
+
+    #region ProblemClass
+    public static DT.ProblemClass ToDto(DA.ProblemClass source) {
+      if (source == null) return null;
+      return new DT.ProblemClass { Id = source.Id, Name = source.Name, Description = source.Description };
+    }
+    public static DA.ProblemClass ToEntity(DT.ProblemClass source) {
+      if (source == null) return null;
+      return new DA.ProblemClass { Id = source.Id, Name = source.Name, Description = source.Description };
+    }
+    public static void ToEntity(DT.ProblemClass source, DA.ProblemClass target) {
+      if ((source != null) && (target != null)) {
+        target.Id = source.Id; target.Name = source.Name; target.Description = source.Description;
+      }
+    }
+    #endregion
+
+    #region Problem
+    public static DT.Problem ToDto(DA.Problem source) {
+      if (source == null) return null;
+      return new DT.Problem { Id = source.Id, Name = source.Name, Description = source.Description, PlatformId = source.PlatformId, ProblemClassId = source.ProblemClassId, DataType = Convert.ToDto(source.DataType) };
+    }
+    public static DA.Problem ToEntity(DT.Problem source, DA.OKBDataContext okb) {
+      if (source == null) return null;
+      return new DA.Problem { Id = source.Id, Name = source.Name, Description = source.Description, PlatformId = source.PlatformId, ProblemClassId = source.ProblemClassId, DataType = Convert.ToEntity(source.DataType, okb) };
+    }
+    public static void ToEntity(DT.Problem source, DA.Problem target, DA.OKBDataContext okb) {
+      if ((source != null) && (target != null)) {
+        target.Id = source.Id; target.Name = source.Name; target.Description = source.Description; target.PlatformId = source.PlatformId; target.ProblemClassId = source.ProblemClassId; target.DataType = Convert.ToEntity(source.DataType, okb);
+      }
+    }
+    #endregion
+
+    #region DataType
+    private static DT.DataType ToDto(DA.DataType source) {
+      if (source == null) return null;
+      return new DT.DataType { Name = source.Name, TypeName = source.TypeName };
+    }
+    private static DA.DataType ToEntity(DT.DataType source, DA.OKBDataContext okb) {
+      if (source == null) return null;
+      var entity = okb.DataTypes.Where(x => (x.Name == source.Name) && (x.TypeName == source.TypeName)).FirstOrDefault();
+      if (entity == null)
+        entity = new DA.DataType() { Id = 0, Name = source.Name, TypeName = source.TypeName };
+      return entity;
+    }
+    #endregion
+
+    #region BinaryData
+    internal static DA.BinaryData ToEntity(byte[] data, DA.OKBDataContext okb) {
+      if (data == null) return null;
+      byte[] hash;
+      using (SHA1 sha1 = SHA1.Create()) {
+        hash = sha1.ComputeHash(data);
+      }
+      var entity = okb.BinaryDatas.Where(x => x.Hash.Equals(hash)).FirstOrDefault();
+      if (entity == null)
+        entity = new DA.BinaryData() { Id = 0, Data = data };
+      return entity;
+    }
+    #endregion
+  }
+}
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/DataTransfer/Algorithm.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/DataTransfer/Algorithm.cs	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/DataTransfer/Algorithm.cs	(revision 5482)
@@ -0,0 +1,34 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.OKB.Administration.DataTransfer {
+  [DataContract]
+  public class Algorithm : NamedOKBItem {
+    [DataMember]
+    public long PlatformId { get; set; }
+    [DataMember]
+    public long AlgorithmClassId { get; set; }
+    [DataMember]
+    public DataType DataType { get; set; }
+  }
+}
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/DataTransfer/AlgorithmClass.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/DataTransfer/AlgorithmClass.cs	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/DataTransfer/AlgorithmClass.cs	(revision 5482)
@@ -0,0 +1,27 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.OKB.Administration.DataTransfer {
+  [DataContract]
+  public class AlgorithmClass : NamedOKBItem { }
+}
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/DataTransfer/DataType.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/DataTransfer/DataType.cs	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/DataTransfer/DataType.cs	(revision 5482)
@@ -0,0 +1,32 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.OKB.Administration.DataTransfer {
+  [DataContract]
+  public class DataType {
+    [DataMember]
+    public string Name { get; set; }
+    [DataMember]
+    public string TypeName { get; set; }
+  }
+}
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/DataTransfer/NamedOKBItem.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/DataTransfer/NamedOKBItem.cs	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/DataTransfer/NamedOKBItem.cs	(revision 5482)
@@ -0,0 +1,32 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.OKB.Administration.DataTransfer {
+  [DataContract]
+  public abstract class NamedOKBItem : OKBItem {
+    [DataMember]
+    public string Name { get; set; }
+    [DataMember]
+    public string Description { get; set; }
+  }
+}
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/DataTransfer/OKBItem.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/DataTransfer/OKBItem.cs	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/DataTransfer/OKBItem.cs	(revision 5482)
@@ -0,0 +1,30 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.OKB.Administration.DataTransfer {
+  [DataContract]
+  public abstract class OKBItem {
+    [DataMember]
+    public long Id { get; set; }
+  }
+}
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/DataTransfer/Platform.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/DataTransfer/Platform.cs	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/DataTransfer/Platform.cs	(revision 5482)
@@ -0,0 +1,27 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.OKB.Administration.DataTransfer {
+  [DataContract]
+  public class Platform : NamedOKBItem { }
+}
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/DataTransfer/Problem.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/DataTransfer/Problem.cs	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/DataTransfer/Problem.cs	(revision 5482)
@@ -0,0 +1,34 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.OKB.Administration.DataTransfer {
+  [DataContract]
+  public class Problem : NamedOKBItem {
+    [DataMember]
+    public long PlatformId { get; set; }
+    [DataMember]
+    public long ProblemClassId { get; set; }
+    [DataMember]
+    public DataType DataType { get; set; }
+  }
+}
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/DataTransfer/ProblemClass.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/DataTransfer/ProblemClass.cs	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Administration/DataTransfer/ProblemClass.cs	(revision 5482)
@@ -0,0 +1,27 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.OKB.Administration.DataTransfer {
+  [DataContract]
+  public class ProblemClass : NamedOKBItem { }
+}
